      program make_haney_coeffs

c
c make masks on the hires ocean grid
c
c note that values over land are irrelevant
c
c we only need to taper over the ocean
c
c the region is defined in the input file region.txt
c in the format
c lat istart iend


      include '/opt/local/include/netcdf.inc'

      parameter(imax=288,imax2=290,jmax=144)

      integer istart(2),icount(2)
      real    xlon0(jmax),xlon1(jmax)
      integer ilon0(jmax),ilon1(jmax)
      real    xlat(jmax)

      real grid(imax,jmax)
      real grid2(imax2,jmax)

      character*160 filename

c open the file
      ncid=ncopn('umgrid_hires.nc',NCWRITE,ir)

c find the variable
      mvarid=ncvid(ncid,'GRID',ir)

c read the data
      istart(1)=1
      istart(2)=1
      icount(1)=imax
      icount(2)=jmax
      call ncvgt(ncid,mvarid,istart,icount,grid,ir)

c read the region file
      open(unit=1,file="region.txt")
      do j=1,144
       read(1,*)xlat(j),xlon0(j),xlon1(j)
       print*,xlat(j),xlon0(j),xlon1(j)
      enddo

c convert longitudes to indices
c longitudes must be stored 0 to 360
      do j=1,144
       ilon0(j)=1+int(xlon0(j)/1.25)
       ilon1(j)=1+int(xlon1(j)/1.25)
      enddo

c apply the region file to the data
c -find the start and finish
      jstart=0
      jend=0
      do j=1,jmax
       jj=jmax+1-j
       if((ilon0(j).ne.ilon1(j)).and.(jstart.eq.0))jstart=j
       if((ilon0(jj).ne.ilon1(jj)).and.(jend.eq.0))jend=jmax+1-j
      enddo
      print*,'starts at line=',jstart
      print*,'ends at line=',jend

c -southern zeroes
      do j=1,jstart-1
       do i=1,imax
        grid(i,j)=0.0
       enddo
      enddo

c -southern taper
      j=jstart
      call onerow(imax,jmax,grid,ilon0,ilon1,j,0.2)
      j=jstart+1
      call onerow(imax,jmax,grid,ilon0,ilon1,j,0.4)
      j=jstart+2
      call onerow(imax,jmax,grid,ilon0,ilon1,j,0.6)
      j=jstart+3
      call onerow(imax,jmax,grid,ilon0,ilon1,j,0.8)

c -main bit
      do j=jstart+4,jend-4
       call onerow(imax,jmax,grid,ilon0,ilon1,j,1.0)
      enddo

c -northern taper
      j=jend-3
      call onerow(imax,jmax,grid,ilon0,ilon1,j,0.8)
      j=jend-2
      call onerow(imax,jmax,grid,ilon0,ilon1,j,0.6)
      j=jend-1
      call onerow(imax,jmax,grid,ilon0,ilon1,j,0.4)
      j=jend
      call onerow(imax,jmax,grid,ilon0,ilon1,j,0.2)

c -northern zeroes
      do j=jend+1,jmax
       do i=1,imax
        grid(i,j)=0.0
       enddo
      enddo

c write the data
      call ncvpt(ncid,mvarid,istart,icount,grid,ir)

c close the file
      call ncclos(ncid,ir)

c set all mv to zero in grid
      do i=1,imax
       do j=1,jmax
        x=grid(i,j)
        if(x.gt.10000)grid(i,j)=0.0
       enddo
      enddo

c copy into the larger array and multiply up
      do i=1,imax2
       do j=1,jmax
        grid2(i,j)=0.0
       enddo
      enddo
      do i=1,imax
       do j=1,jmax
        grid2(i+1,j)=grid(i,j)*163.76
       enddo
      enddo

      print*,'enter a name for the output file'
      read*,filename

c write out in the correct format...
      open(unit=1,file=filename)
      write(1,100)((grid2(i,j),i=1,290),j=1,144)
 100  format(10(f7.1,1x))
      close(1)
      end

c******************************************
      subroutine onerow(imax,jmax,grid,ilon0,ilon1,j,x)

      real grid(imax,jmax)
      integer ilon0(jmax)
      integer ilon1(jmax)
   
      print*,j,x
      do i=ilon0(j),ilon1(j)
       grid(i,j)=x
      enddo

      end


c*********************************
c end of fortran code
c*********************************
